// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{MenuManager, ShortcutManager, ThemeManager};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlApplication")]
    pub struct Application(Object<ffi::DzlApplication, ffi::DzlApplicationClass>) @extends gtk::Application, @implements gio::ActionGroup;

    match fn {
        type_ => || ffi::dzl_application_get_type(),
    }
}

impl Application {
    pub const NONE: Option<&'static Application> = None;

    #[doc(alias = "dzl_application_new")]
    pub fn new(application_id: &str, flags: gio::ApplicationFlags) -> Application {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_application_new(
                application_id.to_glib_none().0,
                flags.into_glib(),
            ))
        }
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Application>> Sealed for T {}
}

pub trait ApplicationExt: IsA<Application> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_application_add_resources")]
    fn add_resources(&self, resource_path: &str) {
        unsafe {
            ffi::dzl_application_add_resources(
                self.as_ref().to_glib_none().0,
                resource_path.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_application_get_menu_by_id")]
    #[doc(alias = "get_menu_by_id")]
    fn menu_by_id(&self, menu_id: &str) -> Option<gio::Menu> {
        unsafe {
            from_glib_none(ffi::dzl_application_get_menu_by_id(
                self.as_ref().to_glib_none().0,
                menu_id.to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_application_get_menu_manager")]
    #[doc(alias = "get_menu_manager")]
    fn menu_manager(&self) -> Option<MenuManager> {
        unsafe {
            from_glib_none(ffi::dzl_application_get_menu_manager(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_application_get_shortcut_manager")]
    #[doc(alias = "get_shortcut_manager")]
    fn shortcut_manager(&self) -> Option<ShortcutManager> {
        unsafe {
            from_glib_none(ffi::dzl_application_get_shortcut_manager(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_application_get_theme_manager")]
    #[doc(alias = "get_theme_manager")]
    fn theme_manager(&self) -> Option<ThemeManager> {
        unsafe {
            from_glib_none(ffi::dzl_application_get_theme_manager(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_application_remove_resources")]
    fn remove_resources(&self, resource_path: &str) {
        unsafe {
            ffi::dzl_application_remove_resources(
                self.as_ref().to_glib_none().0,
                resource_path.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "menu-manager")]
    fn get_property_menu_manager(&self) -> Option<MenuManager> {
        ObjectExt::property(self.as_ref(), "menu-manager")
    }

    #[doc(alias = "menu-manager")]
    fn connect_menu_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_menu_manager_trampoline<
            P: IsA<Application>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlApplication,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Application::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::menu-manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_menu_manager_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "shortcut-manager")]
    fn connect_shortcut_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_shortcut_manager_trampoline<
            P: IsA<Application>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlApplication,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Application::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::shortcut-manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_shortcut_manager_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "theme-manager")]
    fn connect_theme_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_theme_manager_trampoline<
            P: IsA<Application>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlApplication,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Application::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::theme-manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_theme_manager_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<Application>> ApplicationExt for O {}

impl fmt::Display for Application {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Application")
    }
}
